use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum DataScopeInputValue {
    Asset(super::AssetDataScopeInputValue),
    Run(super::RunDataScopeInputValue),
    AssetList(super::AssetListDataScopeInputValue),
    RunList(super::RunListDataScopeInputValue),
    AssetQuery(super::AssetQueryDataScopeInputValue),
    RunQuery(super::RunQueryDataScopeInputValue),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for DataScopeInputValue {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            DataScopeInputValue::Asset(value) => {
                map.serialize_entry(&"type", &"asset")?;
                map.serialize_entry(&"asset", value)?;
            }
            DataScopeInputValue::Run(value) => {
                map.serialize_entry(&"type", &"run")?;
                map.serialize_entry(&"run", value)?;
            }
            DataScopeInputValue::AssetList(value) => {
                map.serialize_entry(&"type", &"assetList")?;
                map.serialize_entry(&"assetList", value)?;
            }
            DataScopeInputValue::RunList(value) => {
                map.serialize_entry(&"type", &"runList")?;
                map.serialize_entry(&"runList", value)?;
            }
            DataScopeInputValue::AssetQuery(value) => {
                map.serialize_entry(&"type", &"assetQuery")?;
                map.serialize_entry(&"assetQuery", value)?;
            }
            DataScopeInputValue::RunQuery(value) => {
                map.serialize_entry(&"type", &"runQuery")?;
                map.serialize_entry(&"runQuery", value)?;
            }
            DataScopeInputValue::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for DataScopeInputValue {
    fn deserialize<D>(d: D) -> Result<DataScopeInputValue, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = DataScopeInputValue;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union DataScopeInputValue")
    }
    fn visit_map<A>(self, mut map: A) -> Result<DataScopeInputValue, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::Asset, Some(Variant_::Asset)) => {
                        let value = map.next_value()?;
                        DataScopeInputValue::Asset(value)
                    }
                    (Variant_::Run, Some(Variant_::Run)) => {
                        let value = map.next_value()?;
                        DataScopeInputValue::Run(value)
                    }
                    (Variant_::AssetList, Some(Variant_::AssetList)) => {
                        let value = map.next_value()?;
                        DataScopeInputValue::AssetList(value)
                    }
                    (Variant_::RunList, Some(Variant_::RunList)) => {
                        let value = map.next_value()?;
                        DataScopeInputValue::RunList(value)
                    }
                    (Variant_::AssetQuery, Some(Variant_::AssetQuery)) => {
                        let value = map.next_value()?;
                        DataScopeInputValue::AssetQuery(value)
                    }
                    (Variant_::RunQuery, Some(Variant_::RunQuery)) => {
                        let value = map.next_value()?;
                        DataScopeInputValue::RunQuery(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            DataScopeInputValue::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::Asset => {
                        let value = map.next_value()?;
                        DataScopeInputValue::Asset(value)
                    }
                    Variant_::Run => {
                        let value = map.next_value()?;
                        DataScopeInputValue::Run(value)
                    }
                    Variant_::AssetList => {
                        let value = map.next_value()?;
                        DataScopeInputValue::AssetList(value)
                    }
                    Variant_::RunList => {
                        let value = map.next_value()?;
                        DataScopeInputValue::RunList(value)
                    }
                    Variant_::AssetQuery => {
                        let value = map.next_value()?;
                        DataScopeInputValue::AssetQuery(value)
                    }
                    Variant_::RunQuery => {
                        let value = map.next_value()?;
                        DataScopeInputValue::RunQuery(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        DataScopeInputValue::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    Asset,
    Run,
    AssetList,
    RunList,
    AssetQuery,
    RunQuery,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::Asset => "asset",
            Variant_::Run => "run",
            Variant_::AssetList => "assetList",
            Variant_::RunList => "runList",
            Variant_::AssetQuery => "assetQuery",
            Variant_::RunQuery => "runQuery",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "asset" => Variant_::Asset,
            "run" => Variant_::Run,
            "assetList" => Variant_::AssetList,
            "runList" => Variant_::RunList,
            "assetQuery" => Variant_::AssetQuery,
            "runQuery" => Variant_::RunQuery,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the DataScopeInputValue union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
